---
sidebar_position: 1
description: How to upgrade to Mapperly v3.0 and a list of all its breaking changes
---

# v3.0

[![Release notes v3.0.0](https://img.shields.io/badge/Release_notes-v3.0-green?style=flat-square)](https://github.com/riok/mapperly/releases/tag/v3.0.0)
[![NuGet v3.0.0](https://img.shields.io/badge/NuGet-v3.0-blue?style=flat-square)](https://www.nuget.org/packages/Riok.Mapperly/3.0.0)
[![API Diff v3.0.0 / v2.8.0](https://img.shields.io/badge/API--Diff-v3.0_%2F_v2.8-yellow?style=flat-square)](https://www.fuget.org/packages/Riok.Mapperly/3.0.0/lib/netstandard2.0/diff/2.8.0/)

## Migration guide

- Replace usages of `MapperIgnoreAttribute` with `MapperIgnoreTargetAttribute` ([details](#mapperignoreattribute-was-removed))
- If your mapper is nested in a class, or the mapped objects include internal members: Add `MapperIgnoreSource`/`MapperIgnoreTarget` for newly included private/internal but unneeded members ([details](#all-accessible-members-are-mapped-by-default))

## MapperIgnoreAttribute was removed

The `MapperIgnoreAttribute` is removed.
Any usages can be replaced with `MapperIgnoreTargetAttribute`.

## All accessible members are mapped by default

Mapperly versions < 3.0 considered all members which are either internal in the same assembly as the mapper or public.
Since v3.0 Mapperly considers all members which are accessible by the mapper.
This can include private members
(e.g. if the mapper is a nested class and maps the outer class which has private members)
and internal members
(e.g. if the mapper maps a class of another assembly which has `InternalsVisibleTo` set for the assembly of the mapper).
If members are now included which you do not want to be mapped,
ignore them by using `MapperIgnoreSource`/`MapperIgnoreTarget`.

## Sealed attributes

All attributes in `Riok.Mapperly.Abstractions` are now sealed.
