---
sidebar_position: 4
description: How the documentation of Mapperly is built.
---

# Documentation

The Mapperly documentation is built using [Docusaurus 2](https://docusaurus.io/)
and is located in the `docs` directory.

## Dependencies

Docusaurus is based on the node ecosystem.
A `.node-version` file provides the node version number to be used.
This file can be interpreted by several node version managers (eg. [fnm](https://github.com/Schniz/fnm) or [nvm](https://github.com/nvm-sh/nvm)).
Make sure you use a node version matching the version in `.node-version` for all following commands.

To install documentation dependencies run:

```bash
npm i
```

### Update generated documentation

To build the generated parts of the documentation
(eg. the API documentation (located in `docs/99-api`), the table of analyzer rules, the samples, ...)
ensure the dotnet solution is built or run `dontet build` in the solutions root directory.
Then run the prebuild script:

```bash
npm run prebuild
```

To reflect changes, this command needs to be re-run each time the source of the generated output changes.

## Local Development

```bash
npm run start
```

This command starts a local development server and opens up a browser window.
Most changes are reflected live without having to restart the server.
The documentation search does not work when using the local development server,
as it depends on the statically built content (see [build](#build)).

## Linting

To run the linters locally run:

```bash
npm run lint
```

To fix detected issues automatically run:

```bash
npm run fix
```

## Build

```bash
npm run build
```

This command generates static content into the `build` directory
and can be served using any static contents hosting service or locally using `npm run serve`.
